#ifndef __EVENTUNIT_H
#define __EVENTUNIT_H
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>

typedef struct
{
    bool reload;            //
    uint32_t count;          //
    uint32_t countSet;            //
}eventParams_ts;

void eventDriver(void);
void setEvent(uint16_t mask, bool reload, uint32_t timeOut_ms);
void event_post(uint16_t mask);
void event_clear(uint16_t mask);
uint16_t event_pend(void);
uint16_t getEvent(uint16_t event, uint16_t mask);
#endif

